package server

import (
	"database/sql"
	"log/slog"
	"net/http"

	"git.runcible.io/learning/ratchet/internal/model"
	"github.com/alexedwards/scs/v2"
	"github.com/go-playground/form/v4"
)

func addRoutes(mux *http.ServeMux,
	logger *slog.Logger,
	tc *TemplateCache,
	db *sql.DB,
	fd *form.Decoder,
	sm *scs.SessionManager,
	snippetService *model.SnippetService) http.Handler {

	// /{$} is used to prevent subtree path patterns from acting like a wildcard
	// resulting in this route requiring an exact match on "/" only
	// You can only include one HTTP method in a route pattern if you choose
	// GET will match GET & HEAD http request methods
	mux.Handle("GET /{$}", sm.LoadAndSave(handleHome(logger, tc, sm, snippetService))) // might be time to swith to github.com/justinas/alice dynamic chain
	mux.Handle("GET /snippet/view/{id}", sm.LoadAndSave(handleSnippetView(logger, tc, sm, snippetService)))
	mux.Handle("GET /snippet/create", sm.LoadAndSave(handleSnippetCreateGet(tc, sm)))
	mux.Handle("POST /snippet/create", sm.LoadAndSave(handleSnippetCreatePost(logger, tc, fd, sm, snippetService)))
	// mux.Handle("/something", handleSomething(logger, config))
	// mux.Handle("/healthz", handleHealthzPlease(logger))
	// mux.Handle("/", http.NotFoundHandler())
	return mux
}
